import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.awt.*;
import javax.swing.filechooser.FileFilter;
import java.io.*;
import javax.media.jai.JAI;
import javax.media.jai.PlanarImage;
import java.util.*;
import java.awt.image.*;
import java.awt.image.renderable.*;
import javax.media.jai.*;
import javax.media.jai.operator.*;

public class ThresholdDlg extends JInternalFrame implements ChangeListener {
    private JSlider m_slSwellValue;
    private PicEdit m_frmParent;
    
    public ThresholdDlg(final PicEdit frmParent) {
        super("Hochpass-Intensitts-Filter...", false, true, false, true);
        this.m_frmParent = frmParent;
        getContentPane().setLayout(new BorderLayout());
        Point parentLoc = frmParent.getLocation();
        setLocation(parentLoc.x + 100, parentLoc.y + 100);
        
        m_slSwellValue = new JSlider(JSlider.HORIZONTAL, 0, 255, 0);
        Hashtable labels = new Hashtable();
        labels.put(new Integer(0), new JLabel("0"));
        labels.put(new Integer(255), new JLabel("255"));
        m_slSwellValue.setLabelTable(labels);
        m_slSwellValue.setPaintLabels(true);
        m_slSwellValue.addChangeListener(this);
        
        JPanel panelButtons = new JPanel();
        JButton btnDo = new JButton("Anwenden");
        JButton btnUnDo = new JButton("Verwerfen");
        panelButtons.add(btnDo);
        panelButtons.add(btnUnDo);
        
        // Eventhandlers...
        btnDo.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                frmParent.setImage();
            }
        });
        btnUnDo.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                frmParent.rollBack();
            }
        });
        
        //Put everything together
        getContentPane().add(m_slSwellValue, BorderLayout.NORTH);
        getContentPane().add(panelButtons, BorderLayout.SOUTH);
        pack();
        frmParent.addChild(this);
    }
    
    public void stateChanged(ChangeEvent e) {
        int nSwellValue = m_slSwellValue.getValue();
        m_frmParent.thresholdImage((double) nSwellValue);
    }
}